/************************************************************************/
/*	Copyright 1987-1991 by Chuck Musciano and Harris Corporation 	*/
/*									*/
/*	Full ownership of this software, and all rights pertaining to 	*/
/*	the for-profit distribution of this software, are retained by 	*/
/*	Chuck Musciano and Harris Corporation.  You are permitted to 	*/
/*	use this software without fee.  This software is provided "as 	*/
/*	is" without express or implied warranty.  You may redistribute 	*/
/*	this software, provided that this copyright notice is retained,	*/
/*	and that the software is not distributed for profit.  If you 	*/
/*	wish to use this software in a profit-making venture, you must 	*/
/*	first license this code and its underlying technology from 	*/
/*	Harris Corporation. 						*/
/*									*/
/*	Bottom line: you can have this software, you can use it, you 	*/
/*	can give it away.  You just can't sell any or all parts of it 	*/
/*	without prior permission from Harris Corporation. 		*/
/************************************************************************/

/************************************************************************/
/*									*/
/*	Definition of an internal BOSS object				*/
/*									*/
/************************************************************************/

#define		MAX_FIELDS		15
#define		MAX_OBJECT_DATA		385

#define		OBJ_TELEPHONE		0
#define		OBJ_SCHEDULE		1
#define		OBJ_MEMO		2
#define		OBJ_CARD		3
#define		OBJ_CALENDAR		4
#define		MAX_OBJECT_KINDS	5

#define		pho_name		field[0]
#define		pho_number		field[1]
#define		pho_address		field[2]
#define		pho_extra_1		field[3]
#define		pho_extra_2		field[4]
#define		pho_extra_3		field[5]
#define		pho_extra_4		field[6]
#define		pho_extra_5		field[7]
#define		pho_extra_6		field[8]

#define		sch_memo		field[0]

#define		mem_memo		field[0]

#define		car_employer		field[0]
#define		car_name		field[1]
#define		car_number		field[2]
#define		car_position		field[3]
#define		car_department		field[4]
#define		car_pobox		field[5]
#define		car_address		field[6]
#define		car_telex		field[7]
#define		car_fax			field[8]
#define		car_extra_1		field[9]
#define		car_extra_2		field[10]
#define		car_extra_3		field[11]
#define		car_extra_4		field[12]
#define		car_extra_5		field[13]
#define		car_extra_6		field[14]

typedef	struct	o_rec	object;

struct	o_rec	{int	kind;
		 int	from_casio;
		 byte	*field[MAX_FIELDS + 1];
		 byte	marked;
		 date	sch_date;
		 time	sch_start_time;
		 time	sch_stop_time;
		 time	sch_alarm_time;
		 date	cal_date;
		 long	cal_marked;
		 object	*next;
		};

PUBLIC	object	*create_object();
PUBLIC	object	*record_to_object();
PUBLIC	object	*text_to_object();
PUBLIC	object	*receive_object();
PUBLIC	int	send_object();

PUBLIC	object	*parsed_object_list;
PUBLIC	int	parse_errors_occured;
