/************************************************************************/
/*	Copyright 1987-1991 by Chuck Musciano and Harris Corporation 	*/
/*									*/
/*	Full ownership of this software, and all rights pertaining to 	*/
/*	the for-profit distribution of this software, are retained by 	*/
/*	Chuck Musciano and Harris Corporation.  You are permitted to 	*/
/*	use this software without fee.  This software is provided "as 	*/
/*	is" without express or implied warranty.  You may redistribute 	*/
/*	this software, provided that this copyright notice is retained,	*/
/*	and that the software is not distributed for profit.  If you 	*/
/*	wish to use this software in a profit-making venture, you must 	*/
/*	first license this code and its underlying technology from 	*/
/*	Harris Corporation. 						*/
/*									*/
/*	Bottom line: you can have this software, you can use it, you 	*/
/*	can give it away.  You just can't sell any or all parts of it 	*/
/*	without prior permission from Harris Corporation. 		*/
/************************************************************************/

/************************************************************************/
/*									*/
/*	Definition of an internal BOSS record				*/
/*									*/
/************************************************************************/

#define		MAX_DATA_LENGTH		255

/* the four kinds of records the BOSS understands */
#define		REC_DATA		0x00
#define		REC_REGISTER		0x01
#define		REC_MODE		0x02
#define		REC_EXIT		0xff

/* address mask for the various kinds of data records */
#define		REC_DATA_DATA		0x8000
#define		REC_DATA_ALARM		0xc000
#define		REC_DATA_BINARY		0xd000
#define		REC_DATA_TIME		0xe000
#define		REC_DATA_DATE		0xf000

#define		REC_DATA_MASK		0xf000
#define		address_kind(x)		((x) & REC_DATA_MASK)
#define		address_start(x)	((x) & ~REC_DATA_MASK)

/* address mask for the various kinds of register records */
#define		REC_REGISTER_NORMAL	0x0000
#define		REC_REGISTER_MARKED	0x8000

/* valid data for the mode record */
#define		REC_MODE_CALENDAR	0x8000
#define		REC_MODE_TELEPHONE	0x9000
#define		REC_MODE_MEMO		0xa000
#define		REC_MODE_SCHEDULE	0xb000
#define		REC_MODE_CARD		0xc000
#define		REC_MODE_INVALID	0xffff

#define		length			u.h.l
#define		address			u.h.a
#define		type			u.h.t

typedef	struct	r_rec	record;

struct	hack	{unsigned	l : 8;
		 unsigned	a : 16;
		 unsigned	t : 8;
		};

struct	r_rec	{union	{struct	hack	h;
			 int		i;
			} u;
		 byte	data[MAX_DATA_LENGTH];
		 record	*next;
		};

PUBLIC	record	*create_record();
PUBLIC	record	*object_to_record();
PUBLIC	int	send_record();
PUBLIC	record	*receive_record();
PUBLIC	record	*make_mode_record();
PUBLIC	record	*make_time_record();
PUBLIC	record	*make_date_record();
